//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <mem.h>
#pragma hdrstop

#include "DataView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDataViewWnd *DataViewWnd;
//---------------------------------------------------------------------------
__fastcall TDataViewWnd::TDataViewWnd(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TDataViewWnd::DMHexClick(TObject *Sender)
{
  DMHex->Checked = true;
  DMText->Checked = false;
  _ShowData();
}
//---------------------------------------------------------------------------

void __fastcall TDataViewWnd::DMTextClick(TObject *Sender)
{
  DMHex->Checked = false;
  DMText->Checked = true;
  _ShowData();
}
//---------------------------------------------------------------------------

void TDataViewWnd::_ShowData()
{
  const char *HEX = "0123456789ABCDEF";
  int i, j,
      COLS,
      WIDTH;

  char *buf,
       *p,
       c,
       stat[16];

  COLS = (((DataView->Width - 24) / 7) - 11) / 4;
  WIDTH = (4 * COLS) + 12;
  CurrCols = COLS;
  if (DMHex->Checked)
  {
    i = WIDTH * ((_Data.size() / COLS) + 1);
    p = new char[i];
    memset(p, ' ', i);
    buf = p;
    for(i = 0; i < (int)_Data.size(); i += COLS)
    {
      sprintf(buf, "%08X", i);
      buf[8] = ' ';
      for(j = i; (j < (int)_Data.size()) && (j < i + COLS); j++)
      {
        buf[10 + (3 * (j % COLS))] = HEX[(_Data[j] >> 4) & 0xF];
        buf[11 + (3 * (j % COLS))] = HEX[_Data[j] & 0xF];
        buf[12 + (3 * (j % COLS))] = ' ';
      }
      for(j = i; (j < (int)_Data.size()) && (j < i + COLS); j++)
      {
        if ((_Data[j] < 32) || (_Data[j] > 126))
          c = '.';
        else
          c = _Data[j];
        buf[((COLS * 3) + 11) + (j % COLS)] = c;
      }
      if (j == (int)_Data.size())
        buf[WIDTH - 1] = 0;
      else
        buf[WIDTH - 1] = '\n';
      buf += WIDTH;
      sprintf(stat, "%3i\%", (i * 100) / _Data.size());
      StatusBar->SimpleText = stat;
    }
    DataView->Text = p;
    delete []p;
  }
  else
    DataView->Text = _DataAS;
}
//---------------------------------------------------------------------------

void TDataViewWnd::SetData(char *p, int len)
{
  int i, j;
  bool t;

  _DataAS = "";
  _DataAS.SetLength(len);
  _Data.clear();
  _Data.resize(len);
  j = 1;
  t = true;
  for(i = 0; i < len; i++)
  {
    if (p[i] > 126)
      _DataAS[j++] = '.';
    else if ((p[i] == 0xA) || (p[i] == 0x9) || (p[i] > 31))
      _DataAS[j++] = p[i];
    else if (p[i] != 0xD)
      t = false;
    _Data[i] = p[i];
  }
  _DataAS.SetLength(j - 1);
  if (t)
  {
    DMHex->Checked = false;
    DMText->Checked = true;
  }
  else
  {
    DMHex->Checked = true;
    DMText->Checked = false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TDataViewWnd::CreateParams(TCreateParams &Params)
{
  TForm::CreateParams(Params);
  Params.ExStyle  |= WS_EX_APPWINDOW;
  Params.WndParent = GetDesktopWindow();
}
//---------------------------------------------------------------------------

void __fastcall TDataViewWnd::FormShow(TObject *Sender)
{
  _ShowData();
}
//---------------------------------------------------------------------------

void __fastcall TDataViewWnd::FormResize(TObject *Sender)
{
  if (((((DataView->Width - 24) / 7) - 11) / 4) != CurrCols)
    _ShowData();  
}
//---------------------------------------------------------------------------

