//---------------------------------------------------------------------------

#ifndef HPIFileH
#define HPIFileH
//---------------------------------------------------------------------------

#include <string>
#include <vector>
#ifdef VCL
#include <ComCtrls.hpp>
#endif

using namespace std;

class HPIFile
{
  public:
    HPIFile();
    ~HPIFile();
    bool ReadFile(const char *fname);
    bool LoadFile(const char *fname, char **buf, int *size);
#ifdef VCL
    void ToTree(TTreeView *tree);
    void ToDir(TListView *list, const char *path);
#endif

    string FileName() { return _filename; }

  private:
    struct _File
    {
      int DataOffset;
      int FileSize;
      char Flag;
    };

    struct _Entry
    {
      string Name;
      vector<_Entry> Entry;
      _File File;
      bool Directory;
    };

    void _LoadEntry(char *buf, char *s, _Entry &entry);
#ifdef VCL
    void _ToTree(TTreeNodes *nodes, TTreeNode *node, _Entry &entry);
#endif
    void _GetDecrypted(char *buf, int len, int pos);
    void _GetCompressed(_File *file, char *buf, bool lz77);
    void _DecompLZ77(const char *in, char *out, int len);
    _Entry *_GetEntryPath(const char *path);
    unsigned int _GetInt(unsigned char *c);
    string &_StrToLower(string &s);

    FILE *_file;
    string _filename;
    int _key;
    _Entry _entry;
};

#endif
