//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <vector>
#include "main.h"
#include "HPIFile.h"
#include "About.h"
#include "DataView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

using namespace std;

TMainWnd *MainWnd;
HPIFile hpifile;
vector<TDataViewWnd *> window;

//---------------------------------------------------------------------------
__fastcall TMainWnd::TMainWnd(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainWnd::MMExitClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::MMOpenClick(TObject *Sender)
{
  TTreeNode *n;

  if (!OpenHPI->Execute())
    return;
  if (!hpifile.ReadFile(OpenHPI->FileName.c_str()))
    Application->MessageBox("Error loading HPI file!", "Open",
                            MB_OK + MB_ICONERROR);
  else
  {
    hpifile.ToTree(DirList);
    n = DirList->Items->GetFirstNode();
    n->Selected = true;
    n->Expanded = true;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::MMExpandAllClick(TObject *Sender)
{
  DirList->FullExpand();
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::MMCollapseAllClick(TObject *Sender)
{
  DirList->FullCollapse();
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::DirListChange(TObject *Sender, TTreeNode *Node)
{
  AnsiString s;

  s = "";
  while (Node != DirList->Items->GetFirstNode())
  {
    s = Node->Text + "/" + s;
    Node = Node->Parent;
  }
  StatusBar->SimpleText = AnsiString(hpifile.FileName().c_str()) + "/" + s;
  hpifile.ToDir(FileList, s.c_str());
}
//---------------------------------------------------------------------------


void __fastcall TMainWnd::MMAboutClick(TObject *Sender)
{
  AboutWnd->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::FileListMenuPopup(TObject *Sender)
{
  FLMView->Enabled = FileList->Selected;
  FLMExtract->Enabled = FileList->Selected;
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::FileListDblClick(TObject *Sender)
{
  if (!FileList->Selected)
    return;
  FLMViewClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::FLMViewClick(TObject *Sender)
{
  TDataViewWnd *w;
  char *b;
  int l;

  if (!hpifile.LoadFile(_GetSelected().c_str(), &b, &l))
  {
    Application->MessageBox("Error extracting file!", "Open",
                            MB_OK + MB_ICONERROR);
    return;
  }
  w = new TDataViewWnd(0);
  w->Caption = "Data Viewer - " + FileList->Selected->Caption;
  w->SetData(b, l);
  delete []b;
  w->Show();
  window.push_back(w);
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::FLMExtractClick(TObject *Sender)
{
  char *b;
  int l;
  FILE *fp;

  if (!hpifile.LoadFile(_GetSelected().c_str(), &b, &l))
  {
    Application->MessageBox("Error extracting file!", "Open",
                            MB_OK + MB_ICONERROR);
    return;
  }
  SaveFile->FileName = FileList->Selected->Caption;
  if (SaveFile->Execute())
  {
    fp = fopen(SaveFile->FileName.c_str(), "wb");
    fwrite(b, l, 1, fp);
    fclose(fp);
  }
  delete []b;
}
//---------------------------------------------------------------------------

AnsiString TMainWnd::_GetSelected()
{
  AnsiString s;
  TTreeNode *n;

  s = "";
  n = DirList->Selected;
  while (n != DirList->Items->GetFirstNode())
  {
    s = n->Text + "/" + s;
    n = n->Parent;
  }
  s += FileList->Selected->Caption;

  return s;
}
//---------------------------------------------------------------------------

void __fastcall TMainWnd::FormClose(TObject *Sender, TCloseAction &Action)
{
  int i;

  for(i = 0; i < (int)window.size(); i++)
    delete window[i];
}
//---------------------------------------------------------------------------

